import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.ArrayList;
import java.util.Map.Entry;
import java.util.TreeMap;

public class NestedJava {

        StreamTokenizer st;

        class Rect /*implements Comparable<Rect>*/ {
                int a,b;
                public Rect(StreamTokenizer st) throws IOException {
                        st.nextToken();
                        a = (int)st.nval;
                        st.nextToken();
                        b = (int)st.nval;
                }
//                public Rect(Scanner in) {
//                        a = in.nextInt();
//                        b = in.nextInt();
//                        sq = ((long)a) * ((long)b);
//                }
                public Rect(int a_, int b_) {
                        a = a_;
                        b = b_;
//                        sq = ((long)a) * ((long)b);
                }
//                public int compareTo(Rect th_t) {
//                        Rect that = (Rect)th_t;
//                        if(this.sq < that.sq) {
//                                return -1;
//                        } else if(this.sq > that.sq) {
//                                return +1;
//                        } else {
//                                return 0;
//                        }
//                }
                public String toString() {
                        return "(" + a + ", " + b + ")";
                }
        }

        class NonDominatedSet {
                TreeMap<Integer,Integer> nds;
                public NonDominatedSet() {
                        nds = new TreeMap<>();
                }
                public NonDominatedSet(Rect r) {
                        nds = new TreeMap<>();
                        nds.put(r.a, r.b);
                }
                public boolean isDominatedBy(Rect r) {
                        Entry<Integer,Integer> loE = nds.lowerEntry(r.a);
                        return loE != null  &&  loE.getValue() < r.b;
                }
                public void insert(Rect r) {
                        if(this.isDominatedBy(r)) {
                                throw new IllegalArgumentException();
                        }
                        Entry<Integer,Integer> ceE = nds.ceilingEntry(r.a);
                        if(ceE != null  &&  ceE.getKey() == r.a && ceE.getValue() <= r.b) {
                                return;
                        }
                        while(ceE != null  &&  ceE.getValue() >= r.b) {
                                nds.remove(ceE.getKey());
                                ceE = nds.ceilingEntry(r.a);
                        }
                        nds.put(r.a, r.b);
                }
                public String toString() {
                        return nds.toString();
                }
        }

        int ceilIdx(ArrayList<NonDominatedSet> maxRectsForLen, Rect r) {
                int left = 0;
                int afterRight = maxRectsForLen.size();
                while(afterRight > left) {
                        int mid = (left + afterRight) / 2;
                        if(maxRectsForLen.get(mid).isDominatedBy(r)) {
                                left = mid + 1;
                        } else {
                                afterRight = mid;
                        }
                }
                return afterRight;
        }

        void run() throws IOException {
//                Scanner in = new Scanner(new File("nested.in"));
//                Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
                StreamTokenizer st = new StreamTokenizer(new BufferedReader(new InputStreamReader(System.in)));
                st.nextToken();
//                int N = in.nextInt();
                int N = (int)st.nval;
                Rect[] data = new Rect[N];
                for(int i=0; i<N; i++) {
//                        data[i] = new Rect(in);
                        data[i] = new Rect(st);
                }
//                in.close();
//                Arrays.sort(data);
                ArrayList<NonDominatedSet> maxRectsForLen = new ArrayList<>();
                for(int i=0; i<N; i++) {
//                        System.out.println("\ni = " + i + " : " + maxRectsForLen);
                        int idx = ceilIdx(maxRectsForLen, data[i]);
//                        System.out.println("data[" + i + "] = " + data[i] + "\tidx = " + idx);
                        if(idx < maxRectsForLen.size()) {
                                maxRectsForLen.get(idx).insert(data[i]);
                        } else {
                                maxRectsForLen.add(new NonDominatedSet(data[i]));
                        }
                }
                System.out.println(maxRectsForLen.size());
//                PrintWriter out = new PrintWriter(new File("nested.out"));
//                out.println(maxRectsForLen.size());
//                out.println(maxRectsForLen.toString());
//                out.close();
        }

        public static void main(String[] args) throws FileNotFoundException {
                NestedJava nj = new NestedJava();
                try {
                        nj.run();
                } catch (IOException e) {
                        // TODO Auto-generated catch block
                        e.printStackTrace();
                }
        }

}