#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <list>
#include <string>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <limits>
#include <algorithm>

// #pragma warning ( disable : 4996 )

using namespace std;

typedef vector<int> vi;
typedef pair<int,int> pii;

vi divisors_all, divisors_except_least_prime, div_renumber;
int greatest_prime;

int calc(short n, int s, long long p, vi::iterator min_v=divisors_all.begin(), bool already_skips_least_prime = false)
{
//        if(n==1)
//                if(s==p)
//                        return 1;
//                else
//                        return 0;
        if(n==2)
        {
                double D = (double)s*s - 4.0*p;
                if(D<0.0)
                                return 0;
                int x1 = (int)(1e-3 + (s + sqrt(D))/2.0);
//                int x2 = (int)(1e-3 + (s - sqrt(D))/2.0);
                if(x1<s && x1>=*min_v && s-x1>=*min_v && (long long)x1*(s-x1)==p)
                        return 1;
                else
                        return 0;
        }
        int max_poss_min_v = s/n;
        double mp_ = pow((double)p, 1.0/n);
        if(mp_ > 1 - 1e-9 + max_poss_min_v)
                return 0;
        else
                max_poss_min_v = min(max_poss_min_v, (int)min(1e9, mp_ + 1e-6 + 1));
//        if(*min_v < greatest_prime)
//        {
//                max_poss_min_v = min(max_poss_min_v, (s - greatest_prime)/(n-1));
//        }
        if(!already_skips_least_prime && p % divisors_all[1] != 0)
        {
                min_v = divisors_except_least_prime.begin() + div_renumber[min_v - divisors_all.begin()];
                already_skips_least_prime = true;
        }
        int result = 0;
        for(vi::iterator v = min_v; *v <= max_poss_min_v; v++)
                if(p % *v == 0)
                        result += calc(n-1, s-*v, p/(*v), v, already_skips_least_prime);
        return result;
}

//int calc(short n, int s, long long p, vi::iterator min_v = divisors.begin())
//{
//        if(n==1)
//                return s==p ? 1 : 0;
//        if(s==p+n-1) // one p, (n-1) times 1
//                return 1;
//        if(s<*min_v && p>1LL)
//                return 0LL;
//        if(n==2)
//        {
//                double D = (double)s*s - 4.0*p;
//                int x1 = (int)(1e-3 + (s + sqrt(D))/2.0);
//                int x2 = (int)(1e-3 + (s - sqrt(D))/2.0);
//                if(x1<=s && (long long)x1*(s-x1)==p)
//                        return 1;
//                else
//                        return 0;
//        }
//        int result = 0;
//        int max_v = min(s/2 ,  s-n+1);
//        for(vi::iterator v = min_v; *v <= max_v; v++)
//        {
//                if(p % *v == 0)
//                        result += calc(n-1, s-*v,  p / *v,  v);
//        }
//        return result;
//}

int get_greatest_prime(long long P)
{
        while(P%2==0)
                P >>= 1;
        for(int p=3; p*p<=P; p+=2)
        {
                while(P%p==0)
                        P/=p;
                if(P==1)
                        return p;
        }
        return P < 0x80000000LL ? (int)P : 0x7FFFFFFF; // ok due to S constraints, but in general it's strange typecast
}

int main(int argc, char* argv[])
{
#ifdef _DEBUG
        freopen("nsp.dat", "rt", stdin);
        freopen("nsp.sol", "wt", stdout);
#endif
        short N;
        int S;
        long long P;
        cin >> N >> S >> P;
        if(N==1)
                if(S==P)
                        cout << "1\n";
                else
                        cout << "0\n";
        else if(P==1LL)
                if(N==S)
                        cout << "1\n";
                else
                        cout << "0\n";
        else
        {
                int sqrt_p = (int)(1e-3+sqrt((double)P));
                if((greatest_prime = get_greatest_prime(P)) > S-N+1)
                        cout << "0\n";
                else
                {
                        for(int p=1; p<=S; p++)
                                if(P % p == 0)
                                {
                                        divisors_all.push_back(p);
                                        div_renumber.push_back(divisors_except_least_prime.size());
                                        if(p>1 && p%divisors_all[1]!=0)
                                                divisors_except_least_prime.push_back(p);
                                };
                        if(divisors_all.size() < 2) // "1" only
                        {
                                if(S==P+N-1) // one "P", N-1
                                        cout << "1\n";
                                else
                                        cout << "0\n";
                        }
                        else
                        {
                                divisors_all.push_back(0x1F001F00);
                                div_renumber.push_back(divisors_except_least_prime.size());
                                divisors_except_least_prime.push_back(0x1F001F00);
                                cout << calc(N,S,P) << endl;
                        }
                }
        }
         return 0;
}