import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.LinkedList;
import java.util.List;
import java.util.Locale;
import java.util.Random;
import java.util.Stack;

public class CycleOfPoints
{
        private final static Random rand = new Random();

        static StreamTokenizer in = new StreamTokenizer(new BufferedReader(new InputStreamReader(System.in)));
        static PrintWriter out = new PrintWriter(System.out);

        static int nextInt() throws Exception {
                in.nextToken();
                return (int)in.nval;
        }

        static String nextString() throws Exception {
                in.nextToken();
                return in.sval;
        }

        public static void main(String[] args) throws Exception {
                int n = nextInt(), q = nextInt();
                tree = null;
                nodes = new Node[n];
                for (int i = 1; i <= n; i++) {
                        tree = add(tree, nodes[i-1] = new Node(i));
                }
                int[] x = new int[n];
                int[] y = new int[n];
                for (int i = 0; i < n; i++) {
                        x[i] = nextInt();
                        y[i] = nextInt();
                }
                for (int r = 0; r < q; r++) {
                        int a = nextInt()-1, b = nextInt()-1;
                        int ra = getIndex(a), rb = getIndex(b);
                        //System.out.println(ra + " " + rb);
                        if (ra > rb) {
                                Node[] split = split(tree, ra-1);
                                tree = merge(split[1], split[0]);
                                reverse(tree, 0, rb + n - ra);
                        }
                        else {
                                reverse(tree, ra-1, rb-1);
                        }
                        //traverse(tree, null);
                        //System.out.println();
                }
                List<Integer> cycle = new LinkedList<Integer>();
                traverse(tree, cycle);
                //System.out.println();
                double ans = 0;
                int prev = -1;
                for (int e : cycle) {
                        if (prev != -1) {
                                ans += Math.hypot(x[e] - x[prev], y[e] - y[prev]);
                        }
                        prev = e;
                }
                ans += Math.hypot(x[cycle.get(0)] - x[prev], y[cycle.get(0)] - y[prev]);
                out.println(String.format(Locale.US, "%.2f",ans));
                out.flush();
        }

        static Node tree;
        static Node[] nodes;

        static int getIndex(int x) {
                Stack<Node> stack = new Stack<Node>();
                Node cur = nodes[x];
                stack.push(cur);
                while (cur.parent != null) {
                        cur = cur.parent;
                        stack.push(cur);
                }
                int res = 0;
                while (true) {
                        Node node = stack.pop();
                        node.push();
                        if (stack.empty()) {
                                res++;
                                if (node.left != null) res += node.left.count;
                                return res;
                        }
                        if (stack.peek() == node.right) {
                                res++;
                                if (node.left != null) res += node.left.count;
                        }
                }
        }

        static Node add(Node tree, Node newNode) {
                return merge(tree, newNode);
        }

        static void traverse(Node tree, List<Integer> list) {
                if (tree == null) return;
                tree.push();
                traverse(tree.left, list);
                if (list != null) list.add(tree.value-1);
                //System.out.print("(" + tree.value +
                                /*", " + (tree.left != null ? tree.left.value : "") +
                                ", " + (tree.right != null ? tree.right.value : "") +
                                ", " + (tree.parent != null ? tree.parent.value : "") +*/
                //                ") ");
                traverse(tree.right, list);
        }

        static Node reverse(Node tree, int from, int to) {
                Node[] leftSplit = split(tree, from);
                Node[] rightSplit = split(leftSplit[1], to - from + 1);
                rightSplit[0].rev = !rightSplit[0].rev;
                return merge(merge(leftSplit[0], rightSplit[0]), rightSplit[1]);
        }

        static Node merge(Node t1, Node t2) {
                if (t1 == null) return t2;
                if (t2 == null) return t1;

                t1.push();
                t2.push();

                if (t1.priority > t2.priority) {
                        t1.right = merge(t1.right, t2);
                        t1.updateCount();
                        return t1;
                }
                else {
                        t2.left = merge(t1, t2.left);
                        t2.updateCount();
                        return t2;
                }
        }

        static Node[] split(Node t, int k) {
                if (t == null) return new Node[]{null, null};

                t.push();

                int index = (t.left != null ? t.left.count : 0);
                if (k <= index) {
                        Node[] rec = split(t.left, k);
                        t.left = rec[1];
                        t.updateCount();
                        t.parent = null;
                        return new Node[]{rec[0], t};
                }
                else {
                        Node[] rec = split(t.right, k - 1 - index);
                        t.right = rec[0];
                        t.updateCount();
                        t.parent = null;
                        return new Node[]{t, rec[1]};
                }
        }

        static class Node {
                int value, count, priority;
                boolean rev;
                Node left, right, parent;

                Node(int value) {
                        this.value = value;
                        this.count = 1;
                        this.priority = rand.nextInt();
                }

                void updateCount() {
                        count = 1;
                        if (left != null) {
                                count += left.count;
                                left.parent = this;
                        }
                        if (right != null) {
                                count += right.count;
                                right.parent = this;
                        }
                }

                void push() {
                        if (!rev) return;
                        rev = !rev;

                        Node temp = left;
                        left = right;
                        right = temp;

                        if (left != null) left.rev = !left.rev;
                        if (right != null) right.rev = !right.rev;
                }
        }
}