#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdbool.h>
#include <assert.h>

#define N 2000
#define M 1000000007

static int a, b, c, d;
static int p[N];
static int tmp[2 * N];

static void add(int p[], int i, int v)
{
   if (i < b)
      p[i] = (p[i] + v) % M;
   else {
      p[i - a] = (p[i - a] + (long long)v * c) % M;
      p[i - b] = (p[i - b] + (long long)v * d) % M;
   }
}

static void sqr_poly(int p[])
{
   int i, j;
   for (i = 0; i < 2 * b - 1; i++)
      tmp[i] = 0;

   for (i = 0; i < b; i++)
      for (j = 0; j < b; j++)
         tmp[i + j] = (tmp[i + j] + (long long)p[i] * p[j]) % M;

   for (i = 2 * b - 2; i >= b; i--)
      add(tmp, i, tmp[i]);

   for (i = 0; i < b; i++)
      p[i] = tmp[i];
}

static void pow_poly(int p[], int k)
{
   int i;
   if (k == 0) {
      for (i = 0; i < b; i++)
         p[i] = 0;
      p[0] = 1;
   } else {
      pow_poly(p, k / 2);
      sqr_poly(p);
      if (k % 2 != 0) {
         int v = p[b - 1];
         for (i = b - 1; i > 0; i--)
            p[i] = p[i - 1];
         p[0] = 0;
         add(p, b, v);
      }
   }
}

int main()
{
   int i;
   int n;
   int res = 0;

   scanf("%d %d %d %d %d", &a, &b, &c, &d, &n);

   pow_poly(p, n + b - 1);
   for (i = 0; i < b; i++)
      res = (res + p[i]) % M;

   printf("%d\n", res);

   return 0;
}